<%--
 * Copyright by Intland Software
 *
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Intland Software. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Intland.
 *
 * $Revision:19952 $ $Date:2007-08-24 19:13:25 +0200 (Fri, 24 Aug 2007) $
--%>
<meta name="decorator" content="main">
<meta name="module" content="tracker">
<meta name="moduleCSSClass" content="trackersModule">
<meta name="stylesheet" content="tracker.css">


<%@ taglib uri="jstl-c" prefix="c" %>
<%@ taglib uri="jstl-fn" prefix="fn" %>

<%@ taglib uri="struts-html" prefix="html" %>
<%@ taglib uri="struts-bean" prefix="bean" %>

<%@ taglib uri="taglib" prefix="tag" %>
<%@ taglib uri="bugstaglib" prefix="bugs" %>
<%@ taglib uri="callTag" prefix="ct" %>

<%
	int counter = 1;
%>

<c:set var="requestURI" value="${param.requestURI}"/>
<c:set var="actionForm" value="${param.actionForm}"/>

<c:set var="tracker_id" value="${param.tracker_id}" />
<c:url var="editUrl" value="${requestURI}">
	<c:param name="tracker_id" value="${tracker_id}" />
</c:url>

<SCRIPT LANGUAGE="JavaScript" type="text/javascript">
<!-- Hide script from old browsers
function submitAction(selector) {
	if (selector != null) {
		var url = '<c:out value="${editUrl}" />';
		var statusId = selector.options[selector.selectedIndex].value;
		if (statusId && statusId.length != 0) {
			url += '&statusId=' + statusId;
		}
		location.href = url;
		return false;
	}
}
// -->
</SCRIPT>

<c:set var="order_by" value="${param.order_by}" />
<c:if test="${empty order_by}">
	<c:set var="order_by" value="layout_offset" />
</c:if>

<c:set var="ascend" value="${param.ascend}" />
<c:if test="${empty ascend}">
	<c:set var="ascend" value="ASC" />
</c:if>

<html:form action="${actionForm}" styleId="adminFieldPermissionForm">

<div class="actionBar">
	<c:choose>
		<c:when test="${canAdminPermission}">
			&nbsp;&nbsp;<html:submit styleClass="button" value="Save" />
			<c:if test="${trackerFieldPermissionForm.resetAvailable}">
				&nbsp;&nbsp;<html:submit styleClass="button" property="SET_FOR_ALL_STATES" value="Apply to every status" title="Apply the same permissions to every status" />
			</c:if>
		</c:when>
		<c:otherwise>
			<script language="javascript">
				YAHOO.util.Event.onDOMReady(function() {
					setEditFieldsDisabled(document.getElementById("adminFieldPermissionForm"), true);
					// still enable the status selectbox to be able to view settings for other statuses
					var statusSelect = document.getElementById("statusSelect");
					statusSelect.disabled = false;
				});
			</script>
		</c:otherwise>
	</c:choose>

	&nbsp;&nbsp;<html:cancel styleClass="button" />

	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Status:&nbsp;
	<html:select property="statusId" styleId="statusSelect" onchange="submitAction(this)">
		<c:forEach items="${trackerFieldPermissionForm.statusList}" var="option">
			<c:choose>
				<c:when test="${option.disabled}">
					<OPTGROUP CLASS="notSelectable" DISABLED LABEL="<c:out value="${option.name}" />"></OPTGROUP>
				</c:when>

				<c:otherwise>
					<html:option value="${option.value}"><c:out value="${option.name}" /></html:option>
				</c:otherwise>
			</c:choose>
		</c:forEach>
	</html:select>
</div>

<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0">

<c:set var="nr_of_roles" value="${fn:length(roles)}" />

<TR CLASS="head">
	<TH CLASS="textCenterData" COLSPAN="8">Fields</TH>

	<tag:tableColumnSeparator header="false" />

	<TH CLASS="textCenterData" COLSPAN="<c:out value="${nr_of_roles * 3}" />">Roles</TH>
</TR>

<TR>
	<TD HEIGHT="1" CLASS="colseparator" COLSPAN="<c:out value="${nr_of_roles * 3 + 8}" />"></TD>
</TR>

<TR CLASS="head">
	<TH>&nbsp;</TH>

	<tag:tableColumnSeparator header="false" />

	<TH>
		<html:hidden property="tracker_id" />
		<html:hidden property="order_by" />
		<html:hidden property="ascend" />
	</TH>

	<TH></TH>
	<tag:tableColumnSeparator header="false" />

	<TH></TH>
	<tag:tableColumnSeparator header="false" />

	<TH></TH>

	<c:forEach items="${roles}" var="role">
		<tag:tableColumnSeparator />

		<TH CLASS="textData" COLSPAN="2"><c:out value="${role.description}" /><html:hidden
			property="role_id" value="${role.id}" /></TH>
	</c:forEach>
</TR>

<TR CLASS="head">
	<tag:sortableHeaderLink
		label="Sequence" orderBy="${order_by}" ascend="${ascend}"
		link="layout_offset" />

	<tag:tableColumnSeparator header="false" />

	<TH>&nbsp;</TH>

	<tag:sortableHeaderLink
		label="Label" orderBy="${order_by}" ascend="${ascend}"
		link="label_text" />

	<tag:tableColumnSeparator header="false" />

	<TH CLASS="textCenterData">Required</TH>

	<tag:tableColumnSeparator header="false" />

	<TH CLASS="textCenterData">Default Value</TH>

	<c:forEach items="${roles}" var="role">
		<tag:tableColumnSeparator />

		<TH CLASS="textCenterData">Read</TH>

		<TH CLASS="textCenterData">Edit</TH>
	</c:forEach>
</TR>

<c:forEach items="${permissions}" var="item">
	<!-- retrieve the current/default value for dynamic choice field -->
	<bean:define id="referenceHandlerSupport" name="trackerFieldPermissionForm" property="referenceHandlerSupport" type="com.intland.codebeamer.servlet.bugs.dynchoices.ReferenceHandlerSupport"/>
	<bean:define id="fieldLayout" name="item" property="labelDto" type="com.intland.codebeamer.persistence.dto.TrackerLayoutLabelDto" />

	<TR VALIGN="top" CLASS="<%=((counter++ % 2) == 0 ? "even" : "odd")%>">

		<TD CLASS="numberData">
			<c:out value="${item.layout_offset}" />
		</TD>

		<tag:tableColumnSeparator />

		<TD><html:checkbox
				title="Select/Clear field permission for all roles"
				property="select_all" value="Select All"
				onclick="setAllStatesByValue(this,'${item.label_id},');" /></TD>

		<TD CLASS="textData"><c:out value="${item.label_text}" escapeXml="false" />
			<html:hidden property="label_ids" value="${item.label_id}" /></TD>

		<tag:tableColumnSeparator />

		<c:set var="onlyVisible" value="${trackerFieldPermissionForm.onlyVisible[item.label_id]}" />

		<%-- Required --%>
		<TD CLASS="textCenterData">
			<c:if test="${!(onlyVisible or item.dependencyField)}">
				<html:multibox property="required" value="${item.label_id}" />
			</c:if>
		</TD>

		<tag:tableColumnSeparator />

		<%-- Default value --%>
		<TD CLASS="textDataWrap">
			<c:if test="${!(onlyVisible or item.dependencyField)}">
				<c:choose>
					<c:when test="${item.labelDto.dynamicChoice}">
						<c:set var="referenceIds" value="<%=referenceHandlerSupport.getCurrentValue(fieldLayout.getTrackerId(),fieldLayout.getId())%>" />
						<bugs:chooseReferences tracker_id="${fieldLayout.trackerId}" ids="${referenceIds}" label="${fieldLayout}"
							setToDefaultLabel="Unset" defaultValue="${referenceHandlerSupport.referencesDefaultValue}" />
					</c:when>
					<c:when test="${item.labelDto.userReferenceField}">
						<!-- retrieve the current/default value for dynamic choice field -->
						<c:set var="referenceIds" value="<%=referenceHandlerSupport.getCurrentValue(fieldLayout.getTrackerId(),fieldLayout.getId())%>" />
						<ct:call return="propertyName"
								object="${referenceHandlerSupport}" method="getPropertyName"
								param1="${tracker_id}" param2="${item.labelDto}" />

						<bugs:userSelector ids="${referenceIds}" fieldName="${propertyName}" showUnset="false" showCurrentUser="false"
								onlyUsersAndRolesWithPermissionsOnTracker="true" tracker_id="${fieldLayout.trackerId}" allowRoleSelection="true"
								setToDefaultLabel="Unset" defaultValue="${referenceHandlerSupport.referencesDefaultValue}"
								/>
					</c:when>
					<c:when test="${item.choiceField}">
						<html:select property="defaultValue(${item.label_id})" styleClass="fixSelectWidth">
							<html:optionsCollection property="defaultValueOptions(${item.label_id})" />
						</html:select>
					</c:when>
					<c:when test="${item.labelDto.booleanField}">
						<html:select property="defaultValue(${item.label_id})" styleClass="fixSelectWidth">
							<html:optionsCollection property="booleanValueOptions" />
						</html:select>
					</c:when>
					<c:otherwise>
						<html:text property="defaultValue(${item.label_id})" styleClass="fixSelectWidth" />
					</c:otherwise>
				</c:choose>
			</c:if>
		</TD>

		<c:forEach items="${roles}" var="role">
			<tag:tableColumnSeparator />

			<c:set var="idx" value="${item.label_id},${role.id}" />

			<TD CLASS="textCenterData">
				<html:multibox property="visible" value="${idx}" title="if '${role.description}' can Read '${item.label_text}' field."/>
			</TD>

			<td CLASS="textCenterData">
				<c:choose>
					<c:when test="${!onlyVisible}">
						<html:multibox property="editable" value="${idx}" title="if '${role.description}' can Edit '${item.label_text}' field." />
					</c:when>
					<c:otherwise>
						<html:hidden property="onlyVisible" value="${idx}" />
					</c:otherwise>
				</c:choose>
			</td>

		</c:forEach>
	</TR>
</c:forEach>

</TABLE>

</html:form>
